#ifdef SYSTEMC
/*
 * $Id$
 *
 * [ Description ]
 * 
 */

#include "Behavioural/Stage_1_Ifetch/Predictor/Meta_Predictor/Two_Level_Branch_Predictor/Two_Level_Branch_Predictor_Glue/include/Two_Level_Branch_Predictor_Glue.h"

namespace morpheo                    {
namespace behavioural {
namespace stage_1_ifetch {
namespace predictor {
namespace meta_predictor {
namespace two_level_branch_predictor {
namespace two_level_branch_predictor_glue {


  void Two_Level_Branch_Predictor_Glue::deallocation (void)
  {
    log_printf(FUNC,Two_Level_Branch_Predictor_Glue,"deallocation","Begin");

    delete in_CLOCK;

    for (uint32_t i=0; i<_param._nb_prediction; i++)
      {
	if (_param._have_bht)
	  {
        delete  in_PREDICT_BHT_ACK             [i];
        delete out_PREDICT_BHT_ADDRESS         [i];
	  }
	if (_param._have_pht)
	  {
        delete  in_PREDICT_PHT_ACK             [i];
        delete out_PREDICT_PHT_ADDRESS         [i];
	  }
	if (_param._have_bht and _param._have_pht)
        delete  in_PREDICT_BHT_HISTORY         [i];
        delete out_PREDICT_ACK                 [i];
        delete  in_PREDICT_ADDRESS             [i];
      }
    if (_param._have_bht)
      {
    delete  in_PREDICT_BHT_ACK    ;
    delete out_PREDICT_BHT_ADDRESS;
      }
    if (_param._have_pht)
      {
    delete  in_PREDICT_PHT_ACK    ;
    delete out_PREDICT_PHT_ADDRESS;
      }
    if (_param._have_bht and _param._have_pht)
    delete  in_PREDICT_BHT_HISTORY;
    
    delete out_PREDICT_ACK        ;
    delete  in_PREDICT_ADDRESS    ;

    for (uint32_t i=0; i<_param._nb_branch_complete; i++)
      {
	if (_param._have_bht)
	  {
        delete  in_BRANCH_COMPLETE_BHT_ACK             [i];
        delete out_BRANCH_COMPLETE_BHT_ADDRESS         [i];
	  }
	if (_param._have_pht)
	  {
        delete  in_BRANCH_COMPLETE_PHT_ACK             [i];
        delete out_BRANCH_COMPLETE_PHT_ADDRESS         [i];
	  }
	if (_param._have_bht and _param._have_pht)
	delete  in_BRANCH_COMPLETE_BHT_HISTORY         [i];
        delete out_BRANCH_COMPLETE_ACK                 [i];
        delete  in_BRANCH_COMPLETE_ADDRESS             [i];
      }
    if (_param._have_bht)
      {
    delete  in_BRANCH_COMPLETE_BHT_ACK    ;
    delete out_BRANCH_COMPLETE_BHT_ADDRESS;
      }
    if (_param._have_pht)
      {
    delete  in_BRANCH_COMPLETE_PHT_ACK    ;
    delete out_BRANCH_COMPLETE_PHT_ADDRESS;
      }
    if (_param._have_bht and _param._have_pht)
    delete  in_BRANCH_COMPLETE_BHT_HISTORY;
    delete out_BRANCH_COMPLETE_ACK        ;
    delete  in_BRANCH_COMPLETE_ADDRESS    ;

    // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    

    log_printf(FUNC,Two_Level_Branch_Predictor_Glue,"deallocation","End");
  };

}; // end namespace two_level_branch_predictor_glue
}; // end namespace two_level_branch_predictor
}; // end namespace meta_predictor
}; // end namespace predictor
}; // end namespace stage_1_ifetch

}; // end namespace behavioural
}; // end namespace morpheo              
#endif
